import * as v from 'valibot';
import {CommonInput} from '../../common';

export const name = 'archive' as const;

export const inputSchema = v.object({
	sourceType: v.literal(name),
	blob: v.blob(),
	type: v.string(),
});

interface ArchiveInput extends CommonInput, v.Output<typeof inputSchema> {}

export class InvalidArchiveTypeError extends Error {}

const extractZip = () => {

};

const extractGzip = () => {

};

const extractTar = () => {

};

export const compileFromInput = async <T extends CommonInput = ArchiveInput>(inputRaw: T) => {
	const input = inputRaw as unknown as ArchiveInput;
	switch (input.type) {
		// TODO get files from archive type
		case 'zip': {
			return extractZip();
		}
		case 'gzip': {
			return extractGzip();
		}
		case 'tar': {
			return extractTar();
		}
		default:
			break;
	}

	throw new InvalidArchiveTypeError('Input type is invalid');
};
