import PuppeteerHTMLPDF from 'puppeteer-html-pdf';
import {BookData} from '../../common';

export const renderFilesAsPdf = async (spine: BookData['spine']) => {
	const pdf = new PuppeteerHTMLPDF();
	await pdf.setOptions({
		preferCSSPageSize: true,
		headless: true,
	});

	return await spine.reduce(
		async (previousPromise, e, i, ee) => {
			const previousBuffers = await previousPromise;
			process.stdout.write(`Rendering file ${i + 1} of ${ee.length}...`);
			await pdf.initializeBrowser();
			const thisPdf = await pdf.create(`file:///${e}`);
			await pdf.closeBrowser();
			process.stdout.write('Done!\n');
			return [
				...previousBuffers,
				thisPdf
			];
		},
		Promise.resolve([] as Buffer[])
	);
};
